#include "igmpproxy.h"

/* 
 * һδȡbrctl, Ⱪ¶ĽӿAPIfind_br,Ϊһпҵ֮Ӧ
 * E8Ŀ, пֻһžbr1, APIе, ڵAPI
 * дΪbr1
 * ͬʱδ뻹һЩ, ĪĴ۸ĳĳЩȫֱڴ, Ҫʹ, Ҫ
 * ϸĵ
*/
#if 0
#ifdef CONFIG_IGMPPROXY_WAN_LAN_BINDING

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <stdio.h>
#include <dirent.h>
#include <errno.h>
#include <string.h>
#include <sys/socket.h>
#include <linux/sockios.h>
#include <sys/ioctl.h>
#include <linux/if_bridge.h>

#define	IFNAMSIZ	16
#define SYSFS_PATH_MAX	256
#define MAX_BRIDGES	1024
#define MAX_PORTS 32
#define dprintf(fmt,arg...)
#define SYSFS_CLASS_NET "/sys/class/net/"
#define BRCTL_GET_BRIDGES 1

static int br_socket_fd = -1;
static char match[sizeof( ((struct ifreq *)NULL)->ifr_name )] = {'\0'};
static unsigned char found = 0;
	
struct bridge_id
{
	unsigned char prio[2];
	unsigned char addr[6];
};

struct bridge_info
{
	struct bridge_id designated_root;
	struct bridge_id bridge_id;
	unsigned root_path_cost;
	struct timeval max_age;
	struct timeval hello_time;
	struct timeval forward_delay;
	struct timeval bridge_max_age;
	struct timeval bridge_hello_time;
	struct timeval bridge_forward_delay;
	u_int16_t root_port;
	unsigned char stp_enabled;
	unsigned char topology_change;
	unsigned char topology_change_detected;
	struct timeval ageing_time;
	struct timeval hello_timer_value;
	struct timeval tcn_timer_value;
	struct timeval topology_change_timer_value;
	struct timeval gc_timer_value;
};


static int isbridge(const struct dirent *entry)
{
	char path[SYSFS_PATH_MAX];
	struct stat st;

	snprintf(path, SYSFS_PATH_MAX, SYSFS_CLASS_NET "%s/bridge", entry->d_name);
	return stat(path, &st) == 0 && S_ISDIR(st.st_mode);
}

static int new_foreach_bridge(int (*iterator)(const char *name, void *), void *arg)
{
	struct dirent **namelist;
	int i, count = 0;

	count = scandir(SYSFS_CLASS_NET, &namelist, isbridge, alphasort);
	if (count < 0)
		return -1;

	for (i = 0; i < count; i++) {
		if (iterator(namelist[i]->d_name, arg))
			break;
	}

	for (i = 0; i < count; i++)
		free(namelist[i]);
	free(namelist);

	return count;
}

static int old_foreach_bridge(int (*iterator)(const char *, void *), void *iarg)
{
	int i, ret=0, num;
	char ifname[IFNAMSIZ];
	int ifindices[MAX_BRIDGES];
	unsigned long args[3] = { BRCTL_GET_BRIDGES, 
		(unsigned long)ifindices, MAX_BRIDGES };

	num = ioctl(br_socket_fd, SIOCGIFBR, args);
	if (num < 0) {
		dprintf("Get bridge indices failed: %s\n",
				strerror(errno));
		return -errno;
	}

	for (i = 0; i < num; i++) {
		if (!if_indextoname(ifindices[i], ifname)) {
			dprintf("get find name for ifindex %d\n",
					ifindices[i]);
			return -errno;
		}

		++ret;
		if(iterator(ifname, iarg)) 
			break;

	}

	return ret;

}

static int br_foreach_bridge(int (*iterator)(const char *, void *), void *arg)
{
	int ret;

	ret = new_foreach_bridge(iterator, arg);
	if (ret <= 0)
		ret = old_foreach_bridge(iterator, arg);

	return ret;
}

static int old_foreach_port(const char *brname,
					    int (*iterator)(const char *br, const char *port, 
												    void *arg),
									    void *arg)
{
	int i, err, count;
	struct ifreq ifr;
	char ifname[IFNAMSIZ];
	int ifindices[MAX_PORTS];
	unsigned long args[4] = { BRCTL_GET_PORT_LIST,
		(unsigned long)ifindices, MAX_PORTS, 0 };

	memset(ifindices, 0, sizeof(ifindices));
	strncpy(ifr.ifr_name, brname, IFNAMSIZ);
	ifr.ifr_data = (char *) &args;

	err = ioctl(br_socket_fd, SIOCDEVPRIVATE, &ifr);
	if (err < 0) {
		dprintf("list ports for bridge:'%s' failed: %s\n",
				brname, strerror(errno));
		return -errno;
	}

	count = 0;
	for (i = 0; i < MAX_PORTS; i++) {
		if (!ifindices[i])
			continue;

		if (!if_indextoname(ifindices[i], ifname)) {
			dprintf("can't find name for ifindex:%d\n",
					ifindices[i]);
			continue;
		}

		++count;
		if (iterator(brname, ifname, arg))
			break;
	}

	return count;
}
	
static int br_foreach_port(const char *brname,
		int (*iterator)(const char *br, const char *port, void *arg),
		void *arg)
{
	int i, count;
	struct dirent **namelist;
	char path[SYSFS_PATH_MAX];

	snprintf(path, SYSFS_PATH_MAX, SYSFS_CLASS_NET "%s/brport", brname);
	count = scandir(path, &namelist, 0, alphasort);
	if (count < 0)
		return old_foreach_port(brname, iterator, arg);

	for (i = 0; i < count; i++) {
		if (iterator(brname, namelist[i]->d_name, arg))
			break;
	}
	for (i = 0; i < count; i++)
		free(namelist[i]);
	free(namelist);

	return count;
}


static int dump_interface(const char *b, const char *p, void *arg)
{
	char *name = (char*)arg;
	if (!strcmp(name, p))
	{
		found = 1;
		return 0;
	}
	return 0;
}

static void br_dump_interface_list(const char *br, void* arg)
{
	int err;

	//first = 1;
	err = br_foreach_port(br, dump_interface, arg);
	if (err < 0)
		printf(" can't get port info: %s\n", strerror(-err));
}

static int show_bridge(const char *name, void *arg)
{
	/* Ѿҵ, Ͳؼв */
	if (found)
	{
		return 1;
	}
	
	strcpy(match, name);
	br_dump_interface_list(name, arg);

	return 0;
}

static int br_init(void)
{
	if ((br_socket_fd = socket(AF_INET, SOCK_STREAM, 0)) < 0)
		return errno;
	return 0;
}

static void br_shutdown()
{
	close(br_socket_fd);
	br_socket_fd = -1;
}


//static int br_cmd_show(const char* devname)
char* find_br(const char* devname)	
{
	match[0] = '\0';
	found = 0;
	br_foreach_bridge(show_bridge, devname);

	if (found)
	{
		return match;
	}
	else
	{
		return NULL;
	}
}

#endif
#endif

#if 0
static void pkt_debug(const char *buf)
{
    int num2print = 20;
    int i = 0;
    if(buf[0]==0x46)
        num2print = 24;
    for (i = 0; i < num2print; i++) {
        printf("%2.2x ", 0xff & buf[i]);
    }
    printf("\n");
    num2print = buf[3];
    for (; i < num2print; i++) {
        printf("%2.2x ", 0xff & buf[i]);
    }
    printf("\n");
}
#else
#define pkt_debug(buf)	do {} while (0)
#endif

#ifndef CONFIG_IGMPPROXY_WAN_LAN_BINDING
static int  igmp_id = 0;

char igmp_down_if_name[IFNAMSIZ];
char igmp_down_if_idx;
#endif

#ifdef CONFIG_IGMPPROXY_MULTIWAN
char igmp_up_if_name[MAXWAN][IFNAMSIZ];
#elif defined CONFIG_IGMPPROXY_WAN_LAN_BINDING
extern IfDesc IfDescVc[MAX_IF];
extern IfDesc* IfDescEp;
#define CONFIG_FILE_LEN 100
static char if_config[CONFIG_FILE_LEN] = {'\0'};
static char bind_config[CONFIG_FILE_LEN] = {'\0'};
#else
char igmp_up_if_name[IFNAMSIZ];
#endif

static char igmpproxy_config[100] = {'\0'};

#ifdef CONFIG_IGMPPROXY_MULTIWAN
char igmp_up_if_idx[MAXWAN];
#elif defined CONFIG_IGMPPROXY_WAN_LAN_BINDING
#else
char igmp_up_if_idx;
#endif

#ifdef CONFIG_IGMPPROXY_MULTIWAN
int igmp_up_if_num;
#endif

int enable_fast_leaving	= 0;
struct mcft_entry *mcpq = NULL;

//int add_mcft(__u32 grp_addr)
struct mcft_entry * add_mcft(__u32 grp_addr, __u32 src_addr
#ifdef CONFIG_IGMPPROXY_WAN_LAN_BINDING
    , int down_if_index
#endif    
    )
{
    struct mcft_entry *mcp;
#ifdef KEEP_GROUP_MEMBER
    struct mbr_entry *gcp;
#endif
    mcp = malloc(sizeof(struct mcft_entry));
    if(!mcp)
        return 0;
#ifdef KEEP_GROUP_MEMBER
    gcp = malloc(sizeof(struct mbr_entry));
    if (!gcp) {
        free(mcp);
        return 0;
    }
#endif
    mcp->grp_addr = grp_addr;
    // Kaohj -- add the first member
#ifdef KEEP_GROUP_MEMBER
    mcp->user_count = 1;
    gcp->user_addr = src_addr;
    gcp->next = NULL;
    mcp->grp_mbr = gcp;
#endif

#ifdef _SUPPORT_IGMPV3_
    mcp->igmp_ver = IGMP_VER_3;
    mcp->filter_mode = MCAST_INCLUDE;
    mcp->srclist = NULL;
    mcp->timer.lefttime = MEMBER_QUERY_INTERVAL;
    mcp->timer.retry_left = MEMBER_QUERY_COUNT;
    mcp->mrt_state = 0;
#endif /*_SUPPORT_IGMPV3_*/

#ifdef CONFIG_IGMPPROXY_WAN_LAN_BINDING
    mcp->down_if_index = down_if_index;
    //mcp->src_addr = src_addr;
#endif
    mcp->next = mcpq;
    mcpq = mcp;
    //return 0;
    return mcp;
}

int del_mcft(__u32 grp_addr, __u32 src_addr)
{
    struct mcft_entry **q, *p;
#ifdef KEEP_GROUP_MEMBER
    struct mbr_entry *gt, *gc;
#endif

    /* Remove the entry from the  list. */
    for (q = &mcpq; (p = *q); q = &p->next) {
        if(p->grp_addr == grp_addr) {

#if 0
#ifdef CONFIG_IGMPPROXY_WAN_LAN_BINDING
            if (p->src_addr != src_addr)
            {
                continue;
            }
#endif
#endif

            *q = p->next;
            // Kaohj -- free member list
#ifdef KEEP_GROUP_MEMBER
            gc = p->grp_mbr;
            while (gc) {
                gt = gc->next;
                free(gc);
                gc = gt;
            }
#endif
#ifdef _SUPPORT_IGMPV3_
            {
                struct src_entry *s, *sn;
                s=p->srclist;
                while(s)
                {
                    sn=s->next;
                    free(s);
                    s=sn;
                }
            }
#endif
            free(p);
            return 0;
        }
    }
    return -1;
}

int chk_mcft(__u32 grp_addr, __u32 src_addr)
{
    struct mcft_entry *mcp = mcpq;
    while(mcp) {
        if(mcp->grp_addr == grp_addr)
        {
#if 0        
#ifdef CONFIG_IGMPPROXY_WAN_LAN_BINDING
            if (mcp->src_addr == src_addr)
#endif
#endif
            return 1;
        }
        mcp = mcp->next;
    }
    return 0;
}

struct mcft_entry * get_mcft(__u32 grp_addr, __u32 src_addr)
{
    struct mcft_entry *mcp = mcpq;
    while(mcp) {
        if(mcp->grp_addr == grp_addr)
        {
#if 0        
#ifdef CONFIG_IGMPPROXY_WAN_LAN_BINDING
            if (src_addr == mcp->src_addr)
#endif
#endif
            return mcp;
        }
        mcp = mcp->next;
    }
    return NULL;
}

int num_mcft(void)
{
    struct mcft_entry *mcp = mcpq;
    int n = 0;
    while(mcp) {
        n++;
        mcp = mcp->next;
    }
    return n;
}

#ifdef KEEP_GROUP_MEMBER
// Kaohj -- attach user to group member list
//	0: fail
//	1: duplicate user
//	2: added successfully
int add_user(struct mcft_entry *mcp, __u32 src)
{
    struct mbr_entry *gcp;

    // check user
    gcp = mcp->grp_mbr;
    while (gcp) {
        if (gcp->user_addr == src)
            return 1;	// user exists
        gcp = gcp->next;
    }

    // add user
    gcp = malloc(sizeof(struct mbr_entry));
    if (!gcp) {
        return 0;
    }
    gcp->user_addr = src;
    gcp->next = mcp->grp_mbr;
    mcp->grp_mbr = gcp;
    mcp->user_count++;
}

// Kaohj -- remove user from group member list
// return: user count
int del_user(struct mcft_entry *mcp, __u32 src)
{
    struct mbr_entry **q, *p;

    /* Remove the entry from the  list. */
    q = &mcp->grp_mbr;
    p = *q;
    while (p) {
        if(p->user_addr == src) {
            *q = p->next;
            free(p);
            mcp->user_count--;
            return mcp->user_count;
        }
        q = &p->next;
        p = p->next;
    }

    return mcp->user_count;
}

#endif

/*
 * u_short in_cksum(u_short *addr, int len)
 *
 * Compute the inet checksum
 */
unsigned short in_cksum(unsigned short *addr, int len)
{
    int nleft = len;
    int sum = 0;
    unsigned short *w = addr;
    unsigned short answer = 0;

    while (nleft > 1) {
        sum += *w++;
        nleft -= 2;
    }
    if (nleft == 1) {
        *(unsigned char*)(&answer) = *(unsigned char*)w;
        sum += answer;
    }
    sum = (sum >> 16) + (sum & 0xffff);
    answer = ~sum;
    return (answer);
}

fd_set in_fds;		/* set of fds that wait_input waits for */
int max_in_fd;		/* highest fd set in in_fds */

/*
 * add_fd - add an fd to the set that wait_input waits for.
 */
void add_fd(int fd)
{
    FD_SET(fd, &in_fds);
    if (fd > max_in_fd)
        max_in_fd = fd;
}

/*
 * remove_fd - remove an fd from the set that wait_input waits for.
 */
void remove_fd(int fd)
{
    FD_CLR(fd, &in_fds);
}

/////////////////////////////////////////////////////////////////////////////
//	22/04/2004, Casey
/*
   Modified the following items:
   1.	delete all muticast router functions, xDSL router never use such function
   2.	igmp_handler only accept message for IGMP PROXY
   3.	IGMP proxy keep track on multicast address by mcft table,
   not multicast router module.

   igmp_handler rule:
   1.	only accept IGMP query from upstream interface, and it trigger
   downstream interface to send IGMP query.
   2.	only accept IGMP report from downstream interface, and it trigger
   upstream interface to send IGMP report.
   3.	when received IGMP report, recorded its group address as forwarding rule.
   4.	only accept IGMP leave from downstream interface, downstream interface
   will send IGMP general query twice to make sure there is no other member.
   If it cannot find any member, upstream interface will send IGMP leave.

   forwarding rule:
   1.	system only forward multicast packets from upstream interface to downstream interface.
   2.	system only forward multicast packets which group address learned by IGMP report.

 */
/////////////////////////////////////////////////////////////////////////////
//



#define RECV_BUF_SIZE	2048
char *recv_buf, *send_buf;
int igmp_socket;	/* down */
int igmp_socket2;	/* up */

int igmp_inf_create(char *ifname)
{
    struct ip_mreq mreq;
    int i;
    int ret;
    struct IfDesc *dp;

    dp = getIfByName(ifname);

    if ((dp->sock = socket(AF_INET, SOCK_RAW, IPPROTO_IGMP)) < 0)
        log(LOG_ERR, errno, "IGMP socket");

#ifdef _SUPPORT_IGMPV3_
    {
        /* Set router alert */
        char ra[4];
        ra[0] = 148;
        ra[1] = 4;
        ra[2] = 0;
        ra[3] = 0;
        setsockopt(dp->sock, IPPROTO_IP, IP_OPTIONS, ra, 4);
    }
#endif /*_SUPPORT_IGMPV3_*/

    /* init igmp */
    /* Set reuseaddr, ttl, loopback and set outgoing interface */
    i = 1;
    ret = setsockopt(dp->sock, SOL_SOCKET, SO_REUSEADDR, (void*)&i, sizeof(i));
    if(ret)
        printf("setsockopt SO_REUSEADDR error!\n");
    i = 1;
    ret = setsockopt(dp->sock, IPPROTO_IP, IP_MULTICAST_TTL,
        (void*)&i, sizeof(i));
    if(ret)
        printf("setsockopt IP_MULTICAST_TTL error!\n");

    //eddie disable LOOP
    i = 0;
    ret = setsockopt(dp->sock, IPPROTO_IP, IP_MULTICAST_LOOP,
        (void*)&i, sizeof(i));
    if(ret)
        printf("setsockopt IP_MULTICAST_LOOP error!\n");
    ret = setsockopt(dp->sock, IPPROTO_IP, IP_MULTICAST_IF,
        (void*)&dp->InAdr, sizeof(struct in_addr));

    if(ret)
        printf("setsockopt IP_MULTICAST_IF error!\n");

    /* In linux use IP_PKTINFO */
    //IP_RECVIF returns the interface of received datagram
    i = 1;
    ret = setsockopt(dp->sock, IPPROTO_IP, IP_PKTINFO, &i, sizeof(i));
    if(ret)
        printf("setsockopt IP_PKTINFO error!\n");

    //ret = fcntl(dp->sock, F_SETFL, O_NONBLOCK);
    //if(ret)
    //	printf("fcntl O_NONBLOCK error!\n");

    return 0;

}

int init_igmp(void)
{
	IGMPPROXY_TRACE("in init_igmp\n");
    int val;
    recv_buf = malloc(RECV_BUF_SIZE);
    send_buf = malloc(RECV_BUF_SIZE);

    FD_ZERO(&in_fds);
    max_in_fd = 0;

#ifdef CONFIG_IGMPPROXY_MULTIWAN
    igmp_inf_create(igmp_down_if_name);
    int idx;
    for(idx=0;idx<igmp_up_if_num;idx++)
        igmp_inf_create(igmp_up_if_name[idx]);
#elif defined CONFIG_IGMPPROXY_WAN_LAN_BINDING
    int i = 0;
	IfDesc *dp;
    for (dp = IfDescVc; dp < IfDescEp; ++dp)
    {
    	//MPPROXY_TRACE("i = %d\n", i);
		// = getIfByIx(i);
		
        if (dp && dp->index != NOT_USED_INTERFACE)
        {
        	IGMPPROXY_TRACE("name = %s\n", dp->Name);
            igmp_inf_create(dp->Name);
        }
		else
		{
			IGMPPROXY_TRACE("NULL\n");
		}
    }
#else
    igmp_inf_create(igmp_down_if_name);
    igmp_inf_create(igmp_up_if_name);
#endif

	IGMPPROXY_TRACE("out init_igmp\n");
    return 0;
}

void shut_igmp_proxy(void)
{
    /* all interface leave multicast group */
}
#ifdef CONFIG_IGMPPROXY_MULTIWAN
int add_mr(__u32 group, __u32 src)
{
    struct ip_mreq mreq;
    struct MRouteDesc	mrd;
    struct IfDesc *up_dp ;
    int index;
    int ret;

    for(index=0;index<igmp_up_if_num;index++)
    {

        up_dp= getIfByName(igmp_up_if_name[index]);

        if(up_dp==NULL)
            continue;
        /* join multicast group */
        mreq.imr_multiaddr.s_addr = group;
        mreq.imr_interface.s_addr = up_dp->InAdr.s_addr;
        ret = setsockopt(up_dp->sock, IPPROTO_IP, IP_ADD_MEMBERSHIP, (void*)&mreq, sizeof(mreq));
        if(ret) {
            fprintf(stderr,"setsockopt IP_ADD_MEMBERSHIP %s error!\n", inet_ntoa(mreq.imr_multiaddr));
            return ret;
        }

        /* add multicast routing entry */
        mrd.OriginAdr.s_addr = 0;
        // Kaohj --- special case, save the subscriber IP to kernel
        // in order to take the subscriber IP (source IP) to the upstream server
        mrd.SubsAdr.s_addr = src;
        mrd.McAdr.s_addr = group;
        mrd.InVif = igmp_up_if_idx[index];
        memset(mrd.TtlVc, 0, sizeof(mrd.TtlVc));
        mrd.TtlVc[igmp_down_if_idx] = 1;
        //  fprintf(stderr,"add mroute %s \n", inet_ntoa(mrd.McAdr));
        addMRoute(&mrd);
    }
    return 1;
}

int del_mr(__u32 group)
{
    struct ip_mreq mreq;
    struct MRouteDesc	mrd;
    struct IfDesc *up_dp ;
    int ret;
    int index;
    for(index=0;index<igmp_up_if_num;index++){
        up_dp= getIfByName(igmp_up_if_name[index]);
        if(up_dp==NULL)
            continue;
        /* drop multicast group */
        mreq.imr_multiaddr.s_addr = group;
        mreq.imr_interface.s_addr = up_dp->InAdr.s_addr;
        ret = setsockopt(up_dp->sock, IPPROTO_IP, IP_DROP_MEMBERSHIP, (void*)&mreq, sizeof(mreq));
        if(ret)
            printf("setsockopt IP_DROP_MEMBERSHIP %s error!\n", inet_ntoa(mreq.imr_multiaddr));

        /* delete multicast routing entry */
        mrd.OriginAdr.s_addr = 0;
        mrd.McAdr.s_addr = group;
        mrd.InVif = igmp_up_if_idx[index];
        memset(mrd.TtlVc, 0, sizeof(mrd.TtlVc));
        //printf("del mroute %s \n", inet_ntoa(mrd.McAdr));
        delMRoute(&mrd);
    }
    return 1;
}

#elif defined CONFIG_IGMPPROXY_WAN_LAN_BINDING
int add_mr(__u32 group, __u32 src, IfDesc *down_dp)
{
    struct ip_mreq mreq;
    struct MRouteDesc	mrd;
    struct IfDesc *up_dp ;
    int ret;

	IGMPPROXY_TRACE("in add_mr\n");
	
    if (down_dp->index < 0)
        return 0;

    //IfDesc *br_dp = find_br(down_dp->Name);
    IfDesc *br_dp = getIfByName("br1");
    if (!br_dp)
    {
        return 0;
    }

    up_dp= getIfByIx(down_dp->index);

    if(up_dp == NULL)
        return 0;
    IGMPPROXY_TRACE("up name = %s, vif = %d\n", up_dp->Name, up_dp->vif_idx);
    IGMPPROXY_TRACE("br name = %s, vif = %d\n", br_dp->Name, br_dp->vif_idx);
    /* join multicast group */
    mreq.imr_multiaddr.s_addr = group;
    mreq.imr_interface.s_addr = up_dp->InAdr.s_addr;
    ret = setsockopt(up_dp->sock, IPPROTO_IP, IP_ADD_MEMBERSHIP, (void*)&mreq, sizeof(mreq));
    if(ret) {
        fprintf(stderr,"setsockopt IP_ADD_MEMBERSHIP %s error!\n", inet_ntoa(mreq.imr_multiaddr));
        return ret;
    }

    /* add multicast routing entry */
    mrd.OriginAdr.s_addr = 0;
    // Kaohj --- special case, save the subscriber IP to kernel
    // in order to take the subscriber IP (source IP) to the upstream server
    mrd.SubsAdr.s_addr = src;
    mrd.McAdr.s_addr = group;
    //mrd.InVif = igmp_up_if_idx[index];
    //mrd.InVif = getIfIndex(up_dp);
    mrd.InVif = up_dp->vif_idx;
	
    memset(mrd.TtlVc, 0, sizeof(mrd.TtlVc));
    //mrd.TtlVc[igmp_down_if_idx] = 1;
    //mrd.TtlVc[getIfIndex(down_dp)] = 1;
    mrd.TtlVc[br_dp->vif_idx] = 1;
    //  fprintf(stderr,"add mroute %s \n", inet_ntoa(mrd.McAdr));
    addMRoute(&mrd);

    return 1;
}

int del_mr(__u32 group, IfDesc *down_dp)
{
    struct ip_mreq mreq;
    struct MRouteDesc	mrd;
    struct IfDesc *up_dp ;
    int ret;

	IGMPPROXY_TRACE("in del_mr\n");

    if (down_dp->index < 0)
    {
        IGMPPROXY_TRACE("index = %d", down_dp->index);
        return 0;
    }

    up_dp= getIfByIx(down_dp->index);
    if(up_dp==NULL)
    {
        IGMPPROXY_TRACE("up_dp NULL\n");
        return 0;
    }

    IGMPPROXY_TRACE("up name = %s, vif = %d\n", up_dp->Name, up_dp->vif_idx);

    /* drop multicast group */
    mreq.imr_multiaddr.s_addr = group;
    mreq.imr_interface.s_addr = up_dp->InAdr.s_addr;
    ret = setsockopt(up_dp->sock, IPPROTO_IP, IP_DROP_MEMBERSHIP, (void*)&mreq, sizeof(mreq));
    if(ret)
        printf("setsockopt IP_DROP_MEMBERSHIP %s error!\n", inet_ntoa(mreq.imr_multiaddr));

    /* delete multicast routing entry */
    mrd.OriginAdr.s_addr = 0;
    mrd.McAdr.s_addr = group;
    //mrd.InVif = igmp_up_if_idx[index];
    //mrd.InVif = getIfIndex(up_dp);
    mrd.InVif = up_dp->vif_idx;
    memset(mrd.TtlVc, 0, sizeof(mrd.TtlVc));
    //printf("del mroute %s \n", inet_ntoa(mrd.McAdr));
    delMRoute(&mrd);

	IGMPPROXY_TRACE("out del_mr\n");	
	
    return 1;
}
#else

int add_mr(__u32 group, __u32 src)
{
    struct ip_mreq mreq;
    struct MRouteDesc	mrd;
    struct IfDesc *up_dp = getIfByName(igmp_up_if_name);
    int ret;

    /* join multicast group */
    mreq.imr_multiaddr.s_addr = group;
    mreq.imr_interface.s_addr = up_dp->InAdr.s_addr;
    ret = setsockopt(up_dp->sock, IPPROTO_IP, IP_ADD_MEMBERSHIP, (void*)&mreq, sizeof(mreq));
    if(ret) {
        printf("setsockopt IP_ADD_MEMBERSHIP %s error!\n", inet_ntoa(mreq.imr_multiaddr));
        return ret;
    }

    /* add multicast routing entry */
    mrd.OriginAdr.s_addr = 0;
    // Kaohj --- special case, save the subscriber IP to kernel
    // in order to take the subscriber IP (source IP) to the upstream server
    mrd.SubsAdr.s_addr = src;
    mrd.McAdr.s_addr = group;
    mrd.InVif = igmp_up_if_idx;
    memset(mrd.TtlVc, 0, sizeof(mrd.TtlVc));
    mrd.TtlVc[igmp_down_if_idx] = 1;
    //printf("add mroute %s \n", inet_ntoa(mrd.McAdr));
    return (addMRoute(&mrd));
}

int del_mr(__u32 group)
{
    struct ip_mreq mreq;
    struct MRouteDesc	mrd;
    struct IfDesc *up_dp = getIfByName(igmp_up_if_name);
    int ret;

    /* drop multicast group */
    mreq.imr_multiaddr.s_addr = group;
    mreq.imr_interface.s_addr = up_dp->InAdr.s_addr;
    ret = setsockopt(up_dp->sock, IPPROTO_IP, IP_DROP_MEMBERSHIP, (void*)&mreq, sizeof(mreq));
    if(ret)
        printf("setsockopt IP_DROP_MEMBERSHIP %s error!\n", inet_ntoa(mreq.imr_multiaddr));

    /* delete multicast routing entry */
    mrd.OriginAdr.s_addr = 0;
    mrd.McAdr.s_addr = group;
    mrd.InVif = igmp_up_if_idx;
    memset(mrd.TtlVc, 0, sizeof(mrd.TtlVc));
    //printf("del mroute %s \n", inet_ntoa(mrd.McAdr));
    delMRoute(&mrd);

    return ret;
}
#endif

void igmp_specific_timer_expired(void *arg)
{
    struct mcft_entry *mcp = arg;

    //printf("igmp_specific_timer_expired()\n");
    if(!mcp)
        return;

    mcp->timer.retry_left--;

#ifdef CONFIG_IGMPPROXY_WAN_LAN_BINDING
    IfDesc *down_dp;
    down_dp = getIfByIx(mcp->down_if_index);
#endif

	if(mcp->timer.retry_left <= 0) {
		untimeout(&mcp->timer.ch);
        // Kaohj --- check if group has already been dropped
		//comment by chenzhihua
//#ifdef KEEP_GROUP_MEMBER
//		if (mcp->user_count != 0) {
//#endif

#ifdef CONFIG_IGMPPROXY_WAN_LAN_BINDING
            del_mr(mcp->grp_addr, down_dp);
            //del_mcft(mcp->grp_addr, mcp->src_addr);
            del_mcft(mcp->grp_addr, 0);
#else
            del_mr(mcp->grp_addr);
            del_mcft(mcp->grp_addr, 0);
#endif
//#ifdef KEEP_GROUP_MEMBER
//		}
//#endif
    }
    else 
    {
        //printf( "<t>\n" );
        timeout(igmp_specific_timer_expired , mcp, LAST_MEMBER_QUERY_INTERVAL, &mcp->timer.ch);
#ifdef CONFIG_IGMPPROXY_WAN_LAN_BINDING
        igmp_query(ALL_SYSTEMS, mcp->grp_addr, LAST_MEMBER_QUERY_INTERVAL, down_dp);
#else
        igmp_query(ALL_SYSTEMS, mcp->grp_addr, LAST_MEMBER_QUERY_INTERVAL);
#endif
    }
}

int add_group_and_src( __u32 group, __u32 src
#ifdef CONFIG_IGMPPROXY_WAN_LAN_BINDING    
    , IfDesc *dp
#endif
    )
{
    struct mcft_entry *mymcp;

    if(!IN_MULTICAST(ntohl(group)))
        return 0;
    /* check if it's protocol reserved group */
    if((group&0xFFFFFF00)==0xE0000000)
        return 0;
    /* TBD */
    /* should check if it's from downtream interface */

    if(!chk_mcft(group, src)) 
    {
        // Group does not exist on router, add multicast address into if_table
        //	struct IfDesc *up_dp = getIfByName(igmp_up_if_name);
        int ret;

#ifdef CONFIG_IGMPPROXY_WAN_LAN_BINDING
        int down_if_index = getIfIndex(dp);
        mymcp = add_mcft(group, src, down_if_index);
#else
        mymcp = add_mcft(group, src);
#endif        
        if(!mymcp) {
            //printf("igmp_accept> add group to list fail!\n");
            return 0;
        }
        // Kaohj
        //add_mr(group);
#ifdef CONFIG_IGMPPROXY_WAN_LAN_BINDING
        add_mr(group, src, dp);
#else
        add_mr(group, src);
#endif

#ifdef PERIODICAL_QUERY
        mymcp->timer.retry_left = MEMBER_QUERY_COUNT;
        timeout(igmp_specific_timer_expired , mymcp, MEMBER_QUERY_INTERVAL, &mymcp->timer.ch);
#endif
    }
    else 
    {
        mymcp = get_mcft(group, src);
        if (mymcp)
        {
            untimeout(&mymcp->timer.ch);
#ifdef KEEP_GROUP_MEMBER
            add_user(mymcp, src);
#endif
#ifdef PERIODICAL_QUERY
            mymcp->timer.retry_left = MEMBER_QUERY_COUNT;
            timeout(igmp_specific_timer_expired , mymcp, MEMBER_QUERY_INTERVAL, &mymcp->timer.ch);
#endif
        }
    }

    return 0;
}

int del_group_and_src( __u32 group, __u32 src )
{
    struct mcft_entry *mymcp;

    if(!IN_MULTICAST(ntohl(group))) {
        //printf("igmp_accept> invalid multicast address or IGMP leave\n");
        return 0;
    }
    //printf("igmp_accept> receive IGMP Leave from %s,", inet_ntoa(ip->saddr));
    //printf("group = %s\n", inet_ntoa(igmp->group));

    /* TBD */
    /* should check if it's from downtream interface */
    if(chk_mcft(group, src)) 
    {
        mymcp = get_mcft(group, src);
        // Group does exist on router
        if(mymcp) 
        {
#ifdef CONFIG_IGMPPROXY_WAN_LAN_BINDING
            IfDesc *down_dp;
            down_dp = getIfByIx(mymcp->down_if_index);
#endif

#ifdef KEEP_GROUP_MEMBER
            int count;
            count = del_user(mymcp, src);
	   if ((count == 0) && enable_fast_leaving)// no member, drop it!
            {
				untimeout(&mymcp->timer.ch);
#ifdef CONFIG_IGMPPROXY_WAN_LAN_BINDING
                del_mr(mymcp->grp_addr, down_dp);
                //del_mcft(mymcp->grp_addr, mymcp->src_addr);
                del_mcft(mymcp->grp_addr, 0);
#else
                del_mr(mymcp->grp_addr);
                del_mcft(mymcp->grp_addr, 0);
#endif
            }
#endif
            mymcp->timer.retry_left = LAST_MEMBER_QUERY_COUNT-1;
            timeout(igmp_specific_timer_expired , mymcp, LAST_MEMBER_QUERY_INTERVAL, &mymcp->timer.ch);
#ifdef CONFIG_IGMPPROXY_WAN_LAN_BINDING
            igmp_query(ALL_SYSTEMS, mymcp->grp_addr, LAST_MEMBER_QUERY_INTERVAL, down_dp);
#else
            igmp_query(ALL_SYSTEMS, mymcp->grp_addr, LAST_MEMBER_QUERY_INTERVAL);
#endif
        }
    }

    return 0;
}

/*
 * igmp_accept - handles the incoming IGMP packets
 *
 */
int igmp_accept(int recvlen, struct IfDesc *dp)
{
    register __u32 src, dst, group, group_src;
    struct iphdr *ip;
    struct igmphdr *igmp;
    int ipdatalen, iphdrlen, igmpdatalen;
    struct mcft_entry *mymcp;

    if (recvlen < sizeof(struct iphdr)) {
        log(LOG_WARNING, 0,
            "received packet too short (%u bytes) for IP header", recvlen);
        return 0;
    }

    ip  = (struct iphdr *)recv_buf;
    src = ip->saddr;
    dst = ip->daddr;

    if(!IN_MULTICAST(ntohl(dst)))	/* It isn't a multicast */
        return -1;
    if(chk_local(src)) 		/* It's our report looped back */
        return -1;
    if(dst == ALL_PRINTER)	/* It's MS-Windows UPNP all printers notify */
        return -1;

    pkt_debug(recv_buf);

    iphdrlen  = ip->ihl << 2;
    ipdatalen = ip->tot_len;

    igmp        = (struct igmphdr *)(recv_buf + iphdrlen);
    group   = igmp->group;

    /* determine message type */
    printf("igmp_accept> receive IGMP type [%x] from %s:", igmp->type, inet_ntoa(ip->saddr));
    printf("%s\n", inet_ntoa(ip->daddr));
    switch (igmp->type) {
    case IGMP_HOST_MEMBERSHIP_QUERY:
        /* Linux Kernel will process local member query, it wont reach here */
        break;

    case IGMP_HOST_MEMBERSHIP_REPORT:
    case IGMPV2_HOST_MEMBERSHIP_REPORT:
#ifdef CONFIG_IGMPPROXY_WAN_LAN_BINDING
        add_group_and_src(group, src, dp);
#else        
        add_group_and_src(group, src );
#endif        
        break;

    case IGMPV3_HOST_MEMBERSHIP_REPORT:
        /* TBD */
        /* should check if it's from downtream interface */
#if 0
        {
            group = *(__u32 *)((char *)igmp+12);
            //igmp_query(ALL_SYSTEMS, group, 1);
            igmp_query(ALL_SYSTEMS, 0, 1);
            break;
        }
#else
        {
            struct igmpv3_report *igmpv3;
            struct igmpv3_grec *igmpv3grec;
            __u16 rec_id;

            igmpv3 = (struct igmpv3_report *)igmp;
            printf( "recv IGMPV3_HOST_MEMBERSHIP_REPORT\n" );
            printf( "igmpv3->type:0x%x\n", igmpv3->type );
            printf( "igmpv3->ngrec:0x%x\n", ntohs(igmpv3->ngrec) );

            rec_id=0;
            igmpv3grec =  &igmpv3->grec[0];
            while( rec_id < ntohs(igmpv3->ngrec) )
            {

                printf( "igmpv3grec[%d]->grec_type:0x%x\n", rec_id, igmpv3grec->grec_type );
                printf( "igmpv3grec[%d]->grec_auxwords:0x%x\n", rec_id, igmpv3grec->grec_auxwords );
                printf( "igmpv3grec[%d]->grec_nsrcs:0x%x\n", rec_id, ntohs(igmpv3grec->grec_nsrcs) );
                printf( "igmpv3grec[%d]->grec_mca:%s\n", rec_id, inet_ntoa(igmpv3grec->grec_mca) );

                group = igmpv3grec->grec_mca;

                switch( igmpv3grec->grec_type )
                {
                case IGMPV3_MODE_IS_INCLUDE:
                case IGMPV3_MODE_IS_EXCLUDE:
                    if(chk_mcft(group, src))
                    {
                        //printf( "IS_IN or IN_EX\n" );
                        //add_group_and_src( group, src );
#ifdef CONFIG_IGMPPROXY_WAN_LAN_BINDING
                        add_group_and_src(group, src, dp);
#else        
                        add_group_and_src(group, src );
#endif        
                    }
                    break;
                case IGMPV3_CHANGE_TO_INCLUDE:
                    //printf( "TO_IN\n" );
                    if( igmpv3grec->grec_nsrcs )
#ifdef CONFIG_IGMPPROXY_WAN_LAN_BINDING
                        add_group_and_src(group, src, dp);
#else        
                        add_group_and_src(group, src );
#endif        
                        //add_group_and_src( group, src );
                    else //empty
                        del_group_and_src( group, src );
                    break;
                case IGMPV3_CHANGE_TO_EXCLUDE:
                    //printf( "TO_EX\n" );
#ifdef CONFIG_IGMPPROXY_WAN_LAN_BINDING
                    add_group_and_src(group, src, dp);
#else        
                    add_group_and_src(group, src );
#endif        
                    //add_group_and_src( group, src );
                    break;
                case IGMPV3_ALLOW_NEW_SOURCES:
                    //printf( "ALLOW\n" );
                    break;
                case IGMPV3_BLOCK_OLD_SOURCES:
                    //printf( "BLOCK\n" );
                    break;
                default:
                    //printf( "!!! can't handle the group record types: %d\n", igmpv3grec->grec_type );
                    break;
                }

                rec_id++;
                printf( "count next: 0x%x %d %d %d %d\n", igmpv3grec, sizeof( struct igmpv3_grec ), igmpv3grec->grec_auxwords, ntohs(igmpv3grec->grec_nsrcs), sizeof( __u32 ) );
                igmpv3grec = (struct igmpv3_grec *)( (char*)igmpv3grec + sizeof( struct igmpv3_grec ) + (igmpv3grec->grec_auxwords+ntohs(igmpv3grec->grec_nsrcs))*sizeof( __u32 ) );
                printf( "count result: 0x%x\n", igmpv3grec );
            }
            break;
        }
#endif
        break;

    case IGMP_HOST_LEAVE_MESSAGE :
        del_group_and_src( group, src );
        break;
    default:
        printf("igmp_accept> receive IGMP Unknown type [%x] from %s:", igmp->type, inet_ntoa(ip->saddr));
        printf("%s\n", inet_ntoa(ip->daddr));
        break;
    }
    return 0;
}


/*
 * igmp_report - send an IGMP Report packet, directly to linkp->send(), not via ip
 *
 * int igmp_report( longword ina, int ifno )
 * Where:
 *	ina	the group address to report.
 *      ifno	interface number
 *
 * Returns:
 *	0	if unable to send report
 *	1	report was sent successfully
 */

int igmp_report(__u32 dst, int if_idx)
{
    struct iphdr *ip;
    struct igmphdr *igmp;
    struct sockaddr_in sdst;

    ip                      = (struct iphdr *)send_buf;
    ip->saddr       = getAddrByVifIx(if_idx);
    ip->daddr       = dst;
    ip->tot_len              = MIN_IP_HEADER_LEN + IGMP_MINLEN;
    if (IN_MULTICAST(ntohl(dst))) {
        ip->ttl = 1;
        if (setsockopt(igmp_socket, IPPROTO_IP, IP_MULTICAST_IF,
                (char *)&ip->saddr, sizeof(struct in_addr)) < 0)
            printf("igmp_report> set multicast interface error\n");

    }
    else
        ip->ttl = MAXTTL;

    igmp                    = (struct igmphdr *)(send_buf + MIN_IP_HEADER_LEN);
    igmp->type         = IGMPV2_HOST_MEMBERSHIP_REPORT;
    igmp->code         = 0;
    igmp->group		   = dst;
    igmp->csum        = 0;
    igmp->csum        = in_cksum((u_short *)igmp, IGMP_MINLEN);

    bzero(&sdst, sizeof(sdst));
    sdst.sin_family = AF_INET;
    sdst.sin_addr.s_addr = dst;
    if (sendto(igmp_socket, send_buf,
            MIN_IP_HEADER_LEN + IGMP_MINLEN, 0,
            (struct sockaddr *)&sdst, sizeof(sdst)) < 0) {
        printf("igmp_report> sendto error, from %s ", inet_ntoa(ip->saddr));
        printf("to %s\n", inet_ntoa(ip->daddr));
    }

    return 1;
}




/*
 * igmp_query - send an IGMP Query packet to downstream interface
 *
 * int igmp_query(__u32 dst, __u32 grp,__u8 mrt)
 * Where:
 *  dst		destination address
 *  grp		query group address
 *  MRT		Max Response Time in IGMP header (in 1/10 second unit)
 *
 * Returns:
 *	0	if unable to send
 *	1	packet was sent successfully
 */

int igmp_query(__u32 dst, __u32 grp,__u8 mrt
#ifdef CONFIG_IGMPPROXY_WAN_LAN_BINDING
    , IfDesc *dp
#endif
)
{
    struct iphdr *ip;
    struct igmphdr *igmp;
    struct sockaddr_in sdst;
	
#ifdef CONFIG_IGMPPROXY_WAN_LAN_BINDING
/*
	char *br_name = find_br(dp->Name);
	if (!br_name)
	{
		IGMPPROXY_TRACE("find_br return NULL\n");
		return 1;
	}
	IGMPPROXY_TRACE("br_name = %s\n", br_name);
*/	
	dp = getIfByName("br1");
	if (!dp)
	{
		return 1;
	}
		
#else
    struct IfDesc *dp = getIfByName(igmp_down_if_name);
#endif

    ip              = (struct iphdr *)send_buf;
    ip->saddr       = dp->InAdr.s_addr;
    ip->daddr       = dst;
    ip->tot_len              = MIN_IP_HEADER_LEN + IGMP_MINLEN;
    ip->ttl = 1;

    igmp               = (struct igmphdr *)(send_buf + MIN_IP_HEADER_LEN);
    igmp->type         = 0x11;
    igmp->code         = mrt;
    igmp->group 	   = grp;
    igmp->csum        = 0;
    igmp->csum        = in_cksum((u_short *)igmp, IGMP_MINLEN);

    bzero(&sdst, sizeof(struct sockaddr_in));
    sdst.sin_family = AF_INET;
    sdst.sin_addr.s_addr = dst;

    //printf("send igmp query\n");
    if (sendto(dp->sock, igmp, IGMP_MINLEN, 0,
            (struct sockaddr *)&sdst, sizeof(sdst)) < 0) {
        printf("igmp_query> sendto error, from %s ", inet_ntoa(ip->saddr));
        printf("to %s\n", inet_ntoa(ip->daddr));
    }

    return 0;
}

/*
 * igmp_leave - send an IGMP LEAVE packet, directly to linkp->send(), not via ip
 *
 * int igmp_leave( longword ina, int ifno )
 * Where:
 *  	ina	the IP address to leave
 *  	ifno	interface number
 *
 * Returns:
 *	0	if unable to send leave
 *	1	report was sent successfully
 */
#if 0
int igmp_leave(__u32 grp, int if_idx)
{

    struct iphdr *ip;
    struct igmphdr *igmp;
    struct sockaddr_in sdst;
    struct IfDesc *dp = getIfByName(igmp_up_if_name);

    ip              = (struct iphdr *)send_buf;
    ip->saddr       = dp->InAdr.s_addr;
    ip->daddr       = ALL_ROUTERS;
    ip->tot_len              = MIN_IP_HEADER_LEN + IGMP_MINLEN;
    ip->ttl = 1;

    igmp               = (struct igmphdr *)(send_buf + MIN_IP_HEADER_LEN);
    igmp->type         = 0x17;
    igmp->code         = 0;
    igmp->group 	   = grp;
    igmp->csum        = 0;
    igmp->csum        = in_cksum((u_short *)igmp, IGMP_MINLEN);

    bzero(&sdst, sizeof(struct sockaddr_in));
    sdst.sin_family = AF_INET;
    sdst.sin_addr.s_addr = ALL_ROUTERS;
    //printf("send igmp leave\n");

    if (sendto(dp->sock, igmp, IGMP_MINLEN, 0,
            (struct sockaddr *)&sdst, sizeof(sdst)) < 0) {
        printf("igmp_leave> sendto error, from %s ", inet_ntoa(ip->saddr));
        printf("to %s\n", inet_ntoa(ip->daddr));
    }

    return 0;
}

#endif




////////////////////////////////////////////////////////////////////////////////////


char* runPath = "/sbin/igmpproxy";
char* pidfile = "/var/run/igmp_pid";

#if 0
static void clean(void)
    /*
     ** Cleans up, i.e. releases allocated resources. Called via atexit().
     **
     */
{
    log( LOG_DEBUG, 0, "clean handler called" );
    disableMRouter();

    unlink(pidfile);
    exit(EXIT_SUCCESS);
}
#endif

/*
 * On hangup, let everyone know we're going away.
 */

void hup(int signum)
{
    (void)signum;

    log( LOG_DEBUG, 0, "clean handler called" );
    disableMRouter();

#ifdef CONFIG_IGMPPROXY_WAN_LAN_BINDING
	//br_shutdown();
#endif

    unlink(pidfile);
    exit(EXIT_SUCCESS);

}

// Kaohj added
// Comes here because upstream or downstream interface ip changed
// Usually, it is used by dynamic interface to sync its interface with
// the igmpproxy local database.
void sigifup(int signum)
{
    (void)signum;
    struct ifreq IfVc[ MAX_IF  ];
    struct ifreq *IfEp, *IfPt;
    struct ifconf IoCtlReq;
    struct IfDesc *Dup, *Ddp;
    int Sock;

    // get information of all the interfaces
    if( (Sock = socket( AF_INET, SOCK_DGRAM, 0 )) < 0 )
        log( LOG_ERR, errno, "RAW socket open" );

    IoCtlReq.ifc_buf = (void *)IfVc;
    IoCtlReq.ifc_len = sizeof( IfVc );

    if( ioctl( Sock, SIOCGIFCONF, &IoCtlReq ) < 0 )
        log( LOG_ERR, errno, "ioctl SIOCGIFCONF" );

    close( Sock );
    IfEp = (void *)((char *)IfVc + IoCtlReq.ifc_len);
#ifdef CONFIG_IGMPPROXY_MULTIWAN
    int index;
    // get descriptors of upstream and downstream interfaces

    Ddp = getIfByName(igmp_down_if_name);
    if ( Ddp == NULL)
        return;

    // update upstream/downstream interface ip into local database
    for( IfPt = IfVc; IfPt < IfEp; IfPt++ ) {

        for(index = 0;index<igmp_up_if_num;index++)
        {
            Dup = getIfByName(igmp_up_if_name[index]);
            if ( Dup == NULL)
                continue;
            if (!strcmp(IfPt->ifr_name, Dup->Name)) {
                Dup->InAdr = ((struct sockaddr_in *)&IfPt->ifr_addr)->sin_addr;
                //printf("update upstream ip to %s\n", inet_ntoa(Dup->InAdr));
            }
        }

        if (!strcmp(IfPt->ifr_name, Ddp->Name)) {
            Ddp->InAdr = ((struct sockaddr_in *)&IfPt->ifr_addr)->sin_addr;
            //printf("update downstream ip to %s\n", inet_ntoa(Ddp->InAdr));
        }
    }

#elif defined CONFIG_IGMPPROXY_WAN_LAN_BINDING
    int index;
    // get descriptors of upstream and downstream interfaces

    // update upstream/downstream interface ip into local database
    for( IfPt = IfVc; IfPt < IfEp; IfPt++ ) 
    {
        for(index = 0;index < MAX_IF; index++)
        {
            Ddp = getIfByIx(index);
            /* find a down if desc */
            if (Ddp == NULL || Ddp->index < 0)
                continue;

            Dup = getIfByIx(Ddp->index);
            if ( Dup == NULL)
                continue;
            if (!strcmp(IfPt->ifr_name, Dup->Name)) 
            {
                Dup->InAdr = ((struct sockaddr_in *)&IfPt->ifr_addr)->sin_addr;
                //printf("update upstream ip to %s\n", inet_ntoa(Dup->InAdr));
            }

            if (!strcmp(IfPt->ifr_name, Ddp->Name)) 
            {
                Ddp->InAdr = ((struct sockaddr_in *)&IfPt->ifr_addr)->sin_addr;
                //printf("update downstream ip to %s\n", inet_ntoa(Ddp->InAdr));
            }
        }

    }

#else

    // get descriptors of upstream and downstream interfaces
    Dup = getIfByName(igmp_up_if_name);
    Ddp = getIfByName(igmp_down_if_name);
    if (Dup == NULL || Ddp == NULL)
        return;

    // update upstream/downstream interface ip into local database
    for( IfPt = IfVc; IfPt < IfEp; IfPt++ ) {
        if (!strcmp(IfPt->ifr_name, Dup->Name)) {
            Dup->InAdr = ((struct sockaddr_in *)&IfPt->ifr_addr)->sin_addr;
            //printf("update upstream ip to %s\n", inet_ntoa(Dup->InAdr));
        }
        else if (!strcmp(IfPt->ifr_name, Ddp->Name)) {
            Ddp->InAdr = ((struct sockaddr_in *)&IfPt->ifr_addr)->sin_addr;
            //printf("update downstream ip to %s\n", inet_ntoa(Ddp->InAdr));
        }
    }
#endif
}

#ifdef CONFIG_IGMPPROXY_WAN_LAN_BINDING
void read_if_config()
{
    char buffer[100] = {0};
    FILE *file = NULL;

    file = fopen(if_config, "r");
    if (!file)
    {
        fprintf(stderr, "open %s error!\n", if_config);
        exit(-1);
    }

    char *p;
    struct IfDesc *Dp;
	char in_down = 0;
	int vif_index;
	
    while (fgets(buffer, 100, file))
    {
        Dp = (IfDesc*)NULL;

        if( '\n'== buffer[strlen(buffer)-1] )
        {
            buffer[strlen(buffer)-1] = '\0';
        }
        p = strtok(buffer, " ");

        do  
        {               
            if (!p || !(Dp = getIfByName(p)))
            {   
                break;
            }   
			vif_index = addVIF(Dp);

			if (!in_down)
			{
				Dp->index = UP_INTERFACE;
				IGMPPROXY_TRACE("up = %s, vif = %d, up index = %d\n"
					, p, vif_index
					, getIfIndex(Dp));
			}
			else
			{
				IGMPPROXY_TRACE("down = %s, vif = %d\n", p, vif_index);
				Dp->index = UP_INTERFACE;			
			}

			p = strtok(NULL, " ");
        } while (p);

		if (!in_down)
		{
			in_down = 1;
		}
        memset(buffer, 0, sizeof(buffer));
    }
}

void read_bind_config()
{
    char buffer[100] = {0};
    FILE *file = NULL;

    file = fopen(bind_config, "r");
    if (!file)
    {
        fprintf(stderr, "open %s error!\n", bind_config);
        exit(-1);
    }

    char *p1, *p2;
    int up_index;
    struct IfDesc *Ddp, *Dup;
    while (fgets(buffer, 100, file))
    {
        up_index = NOT_USED_INTERFACE;
        Ddp = Dup = (IfDesc*)NULL;

        if( '\n' == buffer[strlen(buffer)- 1] )
        {
            buffer[strlen(buffer)- 1] = '\0';
        }
        p1 = strtok(buffer, " ");

        /* get the up interface */
        if (!p1 || !(Dup = getIfByName(p1)))
        {   
            continue;
        }   
		//addVIF(Dup);
		
        up_index = getIfIndex(Dup);
        //up_index = Dup - IfDescVc;

        IGMPPROXY_TRACE("up = %s, vif = %d, up_index = %d\n", p1, getVifIx(Dup), up_index);
        do  
        {   
            p2 = strtok(NULL, " ");

            if (!p2 || !(Ddp = addNewIf(p2)))
			//if (!p2 || !(Ddp = getIfByName(p2)))
            {   
                break;
            }   
			//addVIF(Ddp);
            Ddp->index = up_index;
            IGMPPROXY_TRACE("down = %s\n", p2);
        } while (1);
        memset(buffer, 0, sizeof(buffer));
    }

}

void read_igmpproxy_config()
{
	  FILE *file = NULL;
	  char line_buf[256] = {0};
	  char tmp[50] = {0};
	  char val[50] = {0};

         file = fopen(igmpproxy_config, "r");
	  if (!file)
         {
        	fprintf(stderr, "open %s error!\n", igmpproxy_config);
        	exit(-1);
    	  }
	  while(!feof(file))
	 {
       			 /*ȡһ*/
        		if(NULL == fgets(line_buf, 256,file))
        		{
        			break;
        		}
         		sscanf(line_buf,"%s = %s",tmp,val);
			if(strncmp(tmp,"enable_fast_leave",strlen("enable_fast_leave"))== 0)
			{
				enable_fast_leaving = atoi(val);
			}
			printf("==============%d=======%s====\n",enable_fast_leaving,tmp);
	  }
	
}

void init_interface()
{
	read_if_config();
	read_bind_config();
	read_igmpproxy_config();
}
#endif

/*
 ** Inits the necessary resources for MRouter.
 */
static int initMRouter(void)
{
    int Err;
    int i;
    struct IfDesc *Ddp, *Dup;

    buildIfVc();

	IfDesc *Dp= getIfByName("lo");
	
    switch( Err = enableMRouter() ) {
    case 0: break;
    case EADDRINUSE: log( LOG_ERR, EADDRINUSE, "MC-Router API already in use" ); break;
    default: log( LOG_ERR, Err, "MRT_INIT failed" );
    }

#ifdef CONFIG_IGMPPROXY_MULTIWAN
    Ddp = getIfByName(igmp_down_if_name);

    if (Ddp==NULL )
        return 0;

    /* add downstream interface */
    igmp_down_if_idx = addVIF(Ddp);

    /* add upstream interface */
    for(i = 0;i<igmp_up_if_num;i++)
    {
        Dup = getIfByName(igmp_up_if_name[i]);
        if ( Dup == NULL){

            //	   continue;
            return 0;
        }
        igmp_up_if_idx[i] = addVIF(Dup);
    }
#elif defined CONFIG_IGMPPROXY_WAN_LAN_BINDING
    init_interface();
#else
    Ddp = getIfByName(igmp_down_if_name);
    Dup = getIfByName(igmp_up_if_name);
    if (Ddp==NULL || Dup==NULL)
        return 0;

    /* add downstream interface */
    igmp_down_if_idx = addVIF(Ddp);

    /* add upstream interface */
    igmp_up_if_idx = addVIF(Dup);
#endif

    signal(SIGTERM, hup);
    //atexit( clean );
    return 1;
}

void
write_pid()
{
    FILE *fp = fopen(pidfile, "w+");
    if (fp) {
        fprintf(fp, "%d\n", getpid());
        fclose(fp);
    }
    else
        printf("Cannot create pid file\n");
}

void
clear_pid()
{
    FILE *fp = fopen(pidfile, "w+");
    if (fp) {
        fprintf(fp, "%d\n", 0);
        fclose(fp);
    }
    else
        printf("Cannot create pid file\n");
}

#ifdef CONFIG_IGMPPROXY_MULTIWAN
static int process_multiwan_commandline(int argc, char **argv)
{
    char *_argv[12];
    int _argc = 0;

    int execed = 0;
    int index;
    pid_t pid;

    IGMPPROXY_TRACE("CONFIG_IGMPPROXY_MULTIWAN\n");

    if (argc >= 12) {
        fprintf(stderr, "To many arguments \n");
        exit(1);
    }

    if (strcmp(argv[argc-1], "-D") == 0) {
        argc--;
        execed = 1;
    }

    if(argc < 2) {
        printf("Usage: igmpproxy <up interface> [down interface]\n\n");
        return;
    }
    for (_argc=0; _argc < argc; _argc++ ){
        _argv[_argc] = argv[_argc];

    }

    if (!execed) {
        if ((pid = vfork()) < 0) {
            fprintf(stderr, "vfork failed\n");
            exit(1);
        } else if (pid != 0) {
            exit(0);
        }

        for (_argc=0; _argc < argc; _argc++ )
            _argv[_argc] = argv[_argc];
        _argv[0] = runPath;
        _argv[argc++] = "-D";
        _argv[argc++] = NULL;
        execv(_argv[0], _argv);
        /* Not reached */
        fprintf(stderr, "Couldn't exec\n");
        _exit(1);

    } else {
        setsid();
    }


    if(argc == 2)
        strcpy(igmp_down_if_name, "eth0");
    else
        strcpy(igmp_down_if_name, argv[argc-1]);

    for(index=1;index<argc-1;index++)
        strcpy(igmp_up_if_name[index-1], argv[index]);

    igmp_up_if_num=argc-2;

    return 0;
}
#elif defined CONFIG_IGMPPROXY_WAN_LAN_BINDING
#include <unistd.h>

static int process_wanlan_binding(int argc, char **argv)
{
    IGMPPROXY_TRACE("process_wanlan_binding\n");

    pid_t pid;
    int execed = 0;
    int c = 0;
    while( (c = getopt( argc, argv, "i:b:c:D")) != -1 ) 
    {   
        switch(c) 
        {   
        case 'i':
            strcpy(if_config, optarg);
            break;
        case 'b':
            strcpy(bind_config, optarg);
            break;
         case 'c':
	    strcpy(igmpproxy_config, optarg);
            //enable_fast_leaving = atoi(optarg);
		//printf("============enable_fast_leaving:%d==========",enable_fast_leaving);
            break;
        case 'D':
            execed = 1;
            break;
        }   
    }   

#if 0    
    if (!execed) 
    {
        if ((pid = vfork()) < 0) {
            fprintf(stderr, "vfork failed\n");
            exit(1);
        } 
        else if (pid != 0) 
        {
            exit(0);
        }

        execv(argv[0], _argv);
        /* Not reached */
        fprintf(stderr, "Couldn't exec\n");
        _exit(1);

    } 
    else 
    {
        setsid();
    }
#endif

    if (!strlen(if_config) || !strlen(bind_config))
    {
        IGMPPROXY_TRACE("config file NULL!\n");
        exit(-1);
    }

    return 0;
}
#else
static int process_commandline(int argc, char **argv)
{
    IGMPPROXY_TRACE("process_commandline\n");

    char *_argv[5];
    int _argc = 0;

    pid_t pid;
    int execed = 0;
    int index;

    if (argc >= 5) {
        fprintf(stderr, "To many arguments \n");
        exit(1);
    }

    if (strcmp(argv[argc-1], "-D") == 0) {
        argc--;
        execed = 1;
    }

    if(argc < 2) {
        printf("Usage: igmpproxy <up interface> [down interface]\n\n");
        return;
    }
    for (_argc=0; _argc < argc; _argc++ ){
        _argv[_argc] = argv[_argc];

    }
    if (!execed) {
        if ((pid = vfork()) < 0) {
            fprintf(stderr, "vfork failed\n");
            exit(1);
        } else if (pid != 0) {
            exit(0);
        }

        for (_argc=0; _argc < argc; _argc++ )
            _argv[_argc] = argv[_argc];
        _argv[0] = runPath;
        _argv[argc++] = "-D";
        _argv[argc++] = NULL;
        execv(_argv[0], _argv);
        /* Not reached */
        fprintf(stderr, "Couldn't exec\n");
        _exit(1);

    } else {
        setsid();
    }

    if(argc == 2)
        strcpy(igmp_down_if_name, "eth0");
    else
        strcpy(igmp_down_if_name, argv[2]);

    strcpy(igmp_up_if_name, argv[1]);
}

#endif

extern int MRouterFD;

int main(int argc, char **argv)
{

#ifdef CONFIG_IGMPPROXY_MULTIWAN
	IGMPPROXY_TRACE("CONFIG_IGMPPROXY_MULTIWAN\n");
    process_multiwan_commandline(argc, argv);
#elif defined CONFIG_IGMPPROXY_WAN_LAN_BINDING
	//br_init();
	IGMPPROXY_TRACE("CONFIG_IGMPPROXY_WAN_LAN_BINDING\n");
    process_wanlan_binding(argc, argv);     
#else
	IGMPPROXY_TRACE("normal\n");
    process_commandline(argc, argv);
#endif

    write_pid();

    signal(SIGHUP, hup);
    signal(SIGTERM, hup);
    signal(SIGUSR1, sigifup);

    while (!initMRouter())
    {
        // Kaohj, polling every 2 seconds
        //printf("initMRouter fail\n");
        sleep(2);
    }
    init_igmp();

    add_fd(MRouterFD);

    {
        int flags;
        flags = fcntl(MRouterFD, F_GETFL);
        if (flags == -1 || fcntl(MRouterFD, F_SETFL, flags | O_NONBLOCK) == -1)
            printf("Couldn't set MRouterFD to nonblock: %m");
    } 
	
    /* process loop */
    while(1)
    {
        fd_set in;
        struct timeval tv;
        int ret;
        int recvlen;
        struct IfDesc *IfDp;

#ifdef _SUPPORT_IGMPV3_
        igmpv3_timer();
#else
        calltimeout();
#endif /*_SUPPORT_IGMPV3_*/
        tv.tv_sec = 0;
        tv.tv_usec = 100000;

        in = in_fds;

        ret = select(max_in_fd+1, &in, NULL, NULL, &tv);
        if( ret <= 0 )
		{
			//IGMPPROXY_TRACE("select timeout\n");
            continue;
        }

        if(FD_ISSET(MRouterFD, &in_fds)) 
        {
        	IGMPPROXY_TRACE("recvfrom\n");
            recvlen = recvfrom(MRouterFD, recv_buf, RECV_BUF_SIZE,
                0, NULL, &recvlen);
            if (recvlen < 0) 
            {
                if (errno != EINTR && errno !=EAGAIN) log(LOG_ERR, errno, "recvfrom");
                continue;
            }
			
#ifdef CONFIG_IGMPPROXY_WAN_LAN_BINDING
            /* , ˴SIOCGRECVIF궨һҪͶӦں˰汾ĺ궨ֵһ */
#define SIOCGRECVIF   0x8909 
            char szRecvDev[64] = {0};
        	IGMPPROXY_TRACE( "CONFIG_IGMPPROXY_WAN_LAN_BINDING = [0x%x]\n", SIOCGRECVIF );
            ioctl(MRouterFD, SIOCGRECVIF, szRecvDev);
            IGMPPROXY_TRACE("recv=%s, len = %d\n", szRecvDev, strlen(szRecvDev));
            
            IfDp = getIfByName(szRecvDev);
            if(!IfDp)
            {
                continue;
            }

			/* пڷ͹ı, Ҫת֮󶨵п */
			if (IfDp->index == UP_INTERFACE)
			{
                struct IfDesc *Dp;
                int index = IfDp - IfDescVc;

                for( Dp = IfDescVc; Dp < IfDescEp; Dp++ ) 				
                {
                    if (Dp->index == index)
                    {
                        IGMPPROXY_TRACE("name = %s\n", Dp->Name);
						IfDp = Dp;
						
				#ifdef _SUPPORT_IGMPV3_
			            igmpv3_accept(recvlen, IfDp);
				#else
			            igmp_accept(recvlen, IfDp);
				#endif /*_SUPPORT_IGMPV3_*/
                    }
                }
            }
			else if (IfDp->index == DOWN_INTERFACE)
			{
				continue;
        	}
 			else if (IfDp->index >= 0)	/* п */
 			{
			#ifdef _SUPPORT_IGMPV3_
				igmpv3_accept(recvlen, IfDp);
			#else
				igmp_accept(recvlen, IfDp);
			#endif /*_SUPPORT_IGMPV3_*/
			}
			
#else	/* CONFIG_IGMPPROXY_WAN_LAN_BINDING */
            IfDp = getIfByName(igmp_down_if_name);
	#ifdef _SUPPORT_IGMPV3_
            igmpv3_accept(recvlen, IfDp);
	#else
            igmp_accept(recvlen, IfDp);
	#endif /*_SUPPORT_IGMPV3_*/

#endif

        }

    }

    return 0;
}

